-- Copyright (C) 2010 Noé Falzon

-- This program is  free software:  you can redistribute it and/or modify it
-- under  the terms  of the  GNU General Public License  as published by the
-- Free Software Foundation, version 3 of the License.
--
-- This program  is  distributed  in the hope  that it will  be useful,  but
-- WITHOUT  ANY WARRANTY;  without  even the implied  warranty of MERCHANTA-
-- BILITY  or  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
-- License for more details.
--
-- You should have received a copy of the  GNU General Public License  along
-- with this program. If not, see <http://www.gnu.org/licenses/>.

require "class"

Beacon = class()

function Beacon:init(x,y)
	
	self.x = x
	self.y = y
	
	self.z = game:altitude(x,y)
	
	self.rad = 15
	
	if self.z <= game.sealevel then
		return
	end
	
	return self
end

function Beacon:update(dt)
	
	if self.z <= game.sealevel then
		self.die = true
	end

end

function Beacon:draw()
	
	if game.hot == self then
		gl.PointSize(15)
		gl.Color(col.hot)
	else
		gl.PointSize(10)
		gl.Color(col.buildings)
	end
	
	if (game.camx-self.x)^2 + (game.camy-self.y)^2 + (game.camz)^2< 30^2 then
		
		gl.Enable('LIGHTING')
		
		gl.PushMatrix()
		gl.Translate(self.x,self.y,self.z + 3 + sin(gTicks/500*math.pi*2)*0.05)
		gl.Rotate(90,1,0,0)
		gl.Rotate(gTicks/1000*360,0,1,0)
			
		obj.drawDisplayList(beaconmesh)
		gl.PopMatrix()
		
		gl.Disable('LIGHTING')
	else
		
		gl.Begin('POINTS')
		gl.Vertex(self.x,self.y,self.z + 1)
		gl.End('POINTS')
			
	end
	
	
	
	
	
	if game.hot then
	
		gl.LineWidth(3)
		gl.Begin('LINE_STRIP')
		local n = 60
		for i = 0,n do
			local x = self.x + cos(i/n*2*math.pi)*self.rad
			local y = self.y + sin(i/n*2*math.pi)*self.rad
			local z = game:altitude(x,y) + 2

			gl.Vertex(x,y,z)
		end
		gl.End('LINE_STRIP')
	end
	
end

function Beacon:action()
	
	self.die = true
end
